

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.text.*;


/*
http://stds.sc.ist.ucf.edu/siw/97fall/scripts/user_Paper_info.cfm?&client=SISO_97F_SIW&Paper_Num=97F-SIW-005&process=Presentations
*/
public class 
GetScheduleDelta2 extends Applet
{
    public static final boolean DEBUG = true;
    private TextArea textArea = new TextArea (25, 70);
    boolean printOn = true;
    Vector cities = new Vector();
    boolean discard = false;
    StringBuffer buffer = new StringBuffer();

    /**
    *  Returns the array of city keywords.
    */
    public String[]
    getCities()
    {
       String[] ret = new String[cities.size()];
       CityRecord rec;
       for(int i=0;i<cities.size();i++)
       {
           rec = (CityRecord) cities.elementAt(i);
           ret[i] = new String(rec.abb);
           
       }// end of for
       return ret;

    }// end of getCities()

    /**
    */ 
    public void 
    parseCities(String filename)
    {
       int j,i=0;

       try
       {
       BufferedReader input = new BufferedReader(new FileReader(filename));


       String str;

	   while (null != ((str = input.readLine())) && i<10)
	   {
             str = str.replace('-',' ').trim();

             if(str.length()>0) 
             { 
                 System.out.println (printOn+" "+str);

                 StringTokenizer st = new StringTokenizer(str);

                 int size = st.countTokens();
		 if(size>1)
		 {

                 String a[] = new String[size];

                 for(j=0;j<size;j++) a[j] = new String(st.nextToken());

                 System.out.println (" size : "+size);

		 String rest = a[1];
                 for(j=2;j<size;j++) rest = rest + " " + a[j]; 

		 cities.addElement(new CityRecord(rest,a[0]));
	         i++;

		 }

           }// end of if

       }// end of while

       input.close();
       } catch(java.io.FileNotFoundException fnf) {}
         catch(java.io.IOException ioe) {}

       Enumeration e = cities.elements();
       CityRecord rec;

       while( e.hasMoreElements() )
       {
           rec = (CityRecord) e.nextElement();
           rec.print(System.out);
       }// end of while

       System.out.println(" There are "+cities.size()+" number of cities! ");

    }

    public String filterSTR(String str)
    {
       String retStr = new String();
       int first = 0;
       int last = 0;
       int i;
       boolean ok=true;
       
       //System.out.println("before : "+str);
       for(i=0;i<str.length();i++)
       {
         if(str.charAt(i)=='<') 
         { 
           printOn=false;
           if(last>first) retStr += str.substring(first,last+1);
         }
         else if(str.charAt(i)=='>')
              { printOn=true;
                if(i<(str.length()-1)) first = i+1; 
                last = first; 
              }
         else if(printOn) last=i;

       }
       
       if(printOn && last>first) retStr += str.substring(first);

       //System.out.println("after : "+retStr);
       return retStr;
    }

    public String filter(String str)
    {
       String retStr = new String();
       int first = 0;
       int last = 0;
       int i;
       boolean ok=true;
       
       //System.out.println("before : "+str);
       for(i=0;i<str.length();i++)
       {
         if(str.charAt(i)=='<') 
         { 
           printOn=false;
           if(last>first) retStr += str.substring(first,last+1);
         }
         else if(str.charAt(i)=='>')
              { printOn=true;
                if(i<(str.length()-1)) first = i+1; 
                last = first; 
              }
         else if(printOn) last=i;

       }
       
       if(printOn && last>first) retStr += str.substring(first);

       //System.out.println("after : "+retStr);
       return retStr;
    }

    String
    processCityCode(String str)
    {
       String ret = null;
       StringTokenizer st = new StringTokenizer(str.replace('(',' ').replace(')',' '));
       int size = st.countTokens();
       int i, j, hour;
       String[] a;

       if(size>0)
       {
          a = new String[size];
          for(j=0;j<size;j++) a[j] = st.nextToken();
	  ret = a[size-1];

       }// end of if

       return ret;

    }// end of processCityCode

    String
    processTime(String str)
    {
       String ret = null;
       StringTokenizer st = new StringTokenizer(str.replace(':',' '));
       int size = st.countTokens();
       int i, j, hour;
       String[] a;

       try
       {
          if(size>1)
          {
	     a = new String[size];
	     for(j=0;j<size;j++) a[j] = st.nextToken();
	     hour = Integer.parseInt(a[0].trim());
	     if(size>2&&a[2].equals("PM")&&hour<12) hour+=12;
	     if(size>2) ret = new String("Th,"+hour+":"+a[1]+a[2]);
	     else ret = new String("Th,"+hour+":"+a[1]+"AM");

          }// end of if

       } catch(NumberFormatException nfe) {}

       return ret;

    }// end of processTime

    void
    writeFlights(Vector eFile, String outputF)
    {
       String[] fStr = new String[eFile.size()];
       Enumeration e = eFile.elements();
       String str1;
       int i=0, j, k;
       int number_of_lines=0;
       for(;e.hasMoreElements();)
       {
	  str1 = (String) e.nextElement();
	  if(str1!=null) fStr[number_of_lines++] = str1;
       }  

       for(i=0;i<number_of_lines-1;i++)
          for(j=i+1;j<number_of_lines;j++)
	    if(fStr[i]!=null&&fStr[j]!=null&&fStr[j].equals(fStr[i])) fStr[j]=null;

       try
       {
	  PrintWriter pw = new PrintWriter(new FileOutputStream(outputF));
          for(i=0;i<number_of_lines;i++) if(fStr[i]!=null) pw.println(fStr[i]);
	  pw.close();

       } catch(IOException ioe) {}

    }// end of writeFlights()

    void
    doFilterB(Vector eFile, String outputF )
    {
       String[] fStr = new String[eFile.size()];
       Enumeration e = eFile.elements();
       String str1;
       int i=0, j, k;
       int number_of_lines=0;
       for(;e.hasMoreElements();)
       {
	  str1 = (String) e.nextElement();
	  if(str1!=null) fStr[number_of_lines++] = str1;

       }// end of for

       Vector ret = new Vector();

       if(DEBUG) System.out.println(" in doFilterB() ");
       if(DEBUG) System.out.println(" size of fStr  "+number_of_lines);

       if(DEBUG) 
	  for(j=0;j<i;j++) System.out.println(fStr[j]);

       j=0;
       String buf;

       while(j<number_of_lines)
       {
	  //buf = new StringBuffer();
	  //for(k=0;(j+k)<number_of_lines&&k<7;k++) 
	  //{ buf.append(fStr[j+k]);
	  // }
	  if(j+6<number_of_lines)
	  {
	     String flightNum = new String(fStr[j]);
	     String from = new String(fStr[j+2]);
	     String to = new String(fStr[j+4]);
	     String dep = new String(fStr[j+1]);
	     String arr = new String(fStr[j+3]);
	     String plnType = new String(fStr[j+5]);
	     String oprAirlines = new String(fStr[j+6]);

	     if((dep=processTime(dep))!=null && (arr=processTime(arr))!=null &&
		(from=processCityCode(from))!=null && 
		(to=processCityCode(to))!=null ) 
	     {

	        buf = ( from+" "+to+" "+dep+" "+arr+" "+flightNum+" "+plnType+" "+oprAirlines.replace(' ','_'));
		System.out.println(buf);
		ret.addElement(buf);

	     }// end of if

	  }// end of if

	  j += 7;

       }// end of while

       if(ret.size()>0) writeFlights(ret,outputF);

       if(DEBUG) System.out.println(" out of doFilterB() ");
      
    }// end of doFilterB()

    void
    doFilterA(Vector eFile, String outputF )
    {
       String[] fStr = new String[eFile.size()];
       Enumeration e = eFile.elements();
       String str1;
       int i=0,j;
       int number_of_lines=0;
       for(;e.hasMoreElements();)
       {
	  str1 = (String) e.nextElement();
	  if(str1!=null) fStr[number_of_lines++] = str1;

       }// end of for

       if(DEBUG) System.out.println(" In doFilterA() ");

       if(DEBUG) 
	  for(j=0;j<number_of_lines;j++) System.out.println(fStr[j]);

       Vector e2File = new Vector();
       j=0;
       while(j<number_of_lines)
       {
	  if(fStr[j].startsWith("Delta:"))
	  {
	     j+=3;
	     if(j<number_of_lines&&fStr[j].startsWith("Flight")) j+=11;
	  } 
	  else if(!fStr[j].startsWith("Depart")) e2File.addElement(fStr[j]);

	  j++;

       }// end of while

       if(DEBUG) System.out.println(" size of fStr  "+e2File.size());

       fStr = null;

       doFilterB(e2File,outputF);

       e2File = null;

    }// end of doFilterA()

    //public void doPost(String paperNum)
    public void 
    doPost( String orig, String dest, String month, int day, PrintWriter pw)
    {
	try
	    {
	    URL			url;
	    URLConnection	urlConn;
	    DataOutputStream	printout;
	    DataInputStream	input;

	    // URL of CGI-Bin script.
	    //url = new URL (getCodeBase().toString() + "env.cgi");
            url = new URL("http://www.delta-air.com/cgi-bin/wwwvhost.cgi");
       

	    // URL connection channel.
	    urlConn = url.openConnection();

	    // Let the run-time system (RTS) know that we want input.
	    urlConn.setDoInput (true);

	    // Let the RTS know that we want to do output.
	    urlConn.setDoOutput (true);

	    // No caching, we want the real thing.
	    urlConn.setUseCaches (false);

	    // Specify the content type.
	    urlConn.setRequestProperty
		("Content-Type", "application/x-www-form-urlencoded");

	    // Send POST output.
	    printout = new DataOutputStream (urlConn.getOutputStream ());

        //String orig = "ALB";
        //String dest = "EWR";
        //String dt = "04/10/98";

	    String timeOfDay[] = new String[5];
	    timeOfDay[0] = new String("4a"); 
	    timeOfDay[1] = new String("8A"); 
	    timeOfDay[2] = new String("12n"); 
	    timeOfDay[3] = new String("4p"); 
	    timeOfDay[4] = new String("8p"); 

	    //String content = "org="+orig+"&dest="+dest+"&date="+dt;
	    String content = "Departure="+orig+"&Arrival="+dest+"&MaxFlights=2000"+"&LimitChoice=1"+"&Month="+month+"&Day="+day;

       
        // 
		//"name=" + URLEncoder.encode ("Buford Early") +
		//"&email=" + URLEncoder.encode ("buford@known-space.com");
        
	    
	    printout.writeBytes (content);
	    printout.flush ();
	    printout.close ();
	    String str, str2; 
	    Vector myFile = new Vector(); 

	    // Get response data.
	    input = new DataInputStream (urlConn.getInputStream ());
	    while (null != ((str = input.readLine())))
	    {
		//System.out.println(str);
		str=filter(str).trim();
		if(str.length()>0) //pw.println(filter(str));
		{
		   str2 = filter(str);
		   if(str2.length()>0) myFile.addElement(str2);

		}// end of if 
	         	
	    }// end of while

	    /** We have the file in myFile Vector */

	    if(orig.trim().length()>0 && dest.trim().length()>0)
	       doFilterA(myFile,orig+"_"+dest+"_"+month.replace(':','_')+day);

            return;

        //System.out.println("URL\nhttp://stds.sc.ist.ucf.edu/SIW/97fall/DOCS/PAPERS/97F-SIW-");
        //System.out.println("CONFERENCE\n1997 Fall Simulation Interoperability Workshop");  
        //System.out.println("PAPERNUMBER\n"+paperNum);  

	/*
        Vector flights = new Vector();

        System.out.println ( " Origin : "+orig);
        System.out.println ( " Dest   : "+dest);
        System.out.println ( " Date   : "+dt);

        boolean printOn = false;
        boolean first = true;

	    while (null != ((str = input.readLine())))
		{
           //str = filter(str.trim());
           str = str.replace('-',' ');
           str = str.trim();
		   if(str.length()>0&&str.indexOf("<PRE>")>=0) printOn = true;
		   if(str.length()>0&&str.indexOf("</PRE>")>=0) printOn = false;
		   if(printOn&&str.length()>0) 
           { 
              if(!str.startsWith("Flg")&&!str.startsWith("Airli")&&!str.startsWith("<PRE>")&&str.startsWith("Cont"))
              {
                 if(first)
                 {
                     System.out.println ( );
                     System.out.println ( " Origin : "+orig);
                     System.out.println ( " Dest   : "+dest);
                     System.out.println ( " Date   : "+dt);
                     first = false;
                 }
                 System.out.println (printOn+" "+str);

                 StringTokenizer st = new StringTokenizer(str);
                 int size = st.countTokens();
                 String a[] = new String[size];
                 for(int j=0;j<size;j++) 
                     a[j] = new String(st.nextToken());
                 System.out.println (" size : "+size);

                 FlightRecord rec = 
                     new FlightRecord(orig,dest,a[0],a[1],a[2],a[3],a[4],dt);
                 flights.addElement(rec);

              }
           }
		   //textArea.appendText (str + "\n");
		}

	    input.close ();

        Enumeration e = flights.elements();
        FlightRecord rec;
        //PrintWriter pw = new PrintWriter(new FileWriter("out1"));

        while( e.hasMoreElements() )
        {
           rec = (FlightRecord) e.nextElement();
           rec.print(System.out);
           rec.print(pw);
        }// end of while
        //pw.close();

        //parseCities("city_codes");
	*/

	    // Display response.
	    //add ("Center", textArea);
	    }
	catch (MalformedURLException me)
	    {
	    System.err.println("MalformedURLException: " + me);
	    }
	catch (IOException ioe)
	    {
	    System.err.println("IOException: " + ioe.getMessage());
	    }
	}	// End of method init().



    public void 
    parseCities2(String filename)
    {

       try
       {
          BufferedReader input = new BufferedReader(new FileReader(filename));
          String str;

	  while (null != ((str = input.readLine())))
	  {
             str = str.trim();
	     if(str.length()>0) 
             { 
                 System.out.println (printOn+" "+str);

                 StringTokenizer st = new StringTokenizer(str);
                 int size = st.countTokens();
                 String a[] = new String[size];
		 String rest = new String();
                 for(int j=0;j<size;j++) a[j] = new String(st.nextToken());
                 for(int j=1;j<size;j++) rest += a[j];
                 System.out.println (" size : "+size);
                 if(size>1) cities.addElement(new CityRecord(rest,a[0]));

             }// end of if

          }// end of while

          input.close();

       } catch(java.io.FileNotFoundException fnf) {}
         catch(java.io.IOException ioe) {}

       Enumeration e = cities.elements();
       CityRecord rec;

       while( e.hasMoreElements() )
       {
           rec = (CityRecord) e.nextElement();
           rec.print(System.out);
       }// end of while

       System.out.println(" There are "+cities.size()+" number of cities! ");

    }// end of parseCities2()

    public static void 
    main(String[] argv)
    {
       int t,i,j;
       GetScheduleDelta2 inter = new GetScheduleDelta2();

       if(argv.length>1) 
       { 
          inter.parseCities2(argv[0]);
          String ctys[] = inter.getCities();

          for(t=1;t<2;t++)

          try
          { 
	       PrintWriter pw = new PrintWriter(new FileWriter(argv[1]+t),true);
           
               //for(i=0;i<ctys.length;i++)
               for(i=30;i<40;i++)
                  for(j=0;j<ctys.length;j++)
                     if(i!=j&&ctys[i]!=null&&ctys[i].trim().length()>0&&
			ctys[j]!=null&&ctys[j].trim().length()>0) 
			    inter.doPost(ctys[i],ctys[j],"98:May",t,pw);


               pw.close();

          } catch(java.io.IOException ioe) {}

       }// end of if

    }// end of main()

}// End of class GetPaper.

